diff --git a/gcc/diagnostic-show-locus.c b/gcc/diagnostic-show-locus.c
index 54e2b1c..6b2111c 100644
--- a/gcc/diagnostic-show-locus.c
+++ b/gcc/diagnostic-show-locus.c
@@ -271,7 +271,7 @@ colorizer::colorizer (diagnostic_context *context,
   m_range2 = get_color_by_name ("range2");
   m_fixit_insert = get_color_by_name ("fixit-insert");
   m_fixit_delete = get_color_by_name ("fixit-delete");
-  m_stop_color = colorize_stop (pp_show_color (context->printer));
+  m_stop_color = colorize_stop (pp_show_color (context->m_printer));
 }
 
 /* The destructor for "colorize".  If colorization is on, print a code to
@@ -307,35 +307,35 @@ colorizer::begin_state (int state)
       break;
 
     case STATE_FIXIT_INSERT:
-      pp_string (m_context->printer, m_fixit_insert);
+      pp_string (m_context->m_printer, m_fixit_insert);
       break;
 
     case STATE_FIXIT_DELETE:
-      pp_string (m_context->printer, m_fixit_delete);
+      pp_string (m_context->m_printer, m_fixit_delete);
       break;
 
     case 0:
       /* Make range 0 be the same color as the "kind" text
 	 (error vs warning vs note).  */
       pp_string
-	(m_context->printer,
-	 colorize_start (pp_show_color (m_context->printer),
+	(m_context->m_printer,
+	 colorize_start (pp_show_color (m_context->m_printer),
 			 diagnostic_get_color_for_kind (m_diagnostic_kind)));
       break;
 
     case 1:
-      pp_string (m_context->printer, m_range1);
+      pp_string (m_context->m_printer, m_range1);
       break;
 
     case 2:
-      pp_string (m_context->printer, m_range2);
+      pp_string (m_context->m_printer, m_range2);
       break;
 
     default:
       /* For ranges beyond 2, alternate between color 1 and color 2.  */
       {
 	gcc_assert (state > 2);
-	pp_string (m_context->printer,
+	pp_string (m_context->m_printer,
 		   state % 2 ? m_range1 : m_range2);
       }
       break;
@@ -348,7 +348,7 @@ void
 colorizer::finish_state (int state)
 {
   if (state != STATE_NORMAL_TEXT)
-    pp_string (m_context->printer, m_stop_color);
+    pp_string (m_context->m_printer, m_stop_color);
 }
 
 /* Get the color code for NAME (or the empty string if
@@ -357,7 +357,7 @@ colorizer::finish_state (int state)
 const char *
 colorizer::get_color_by_name (const char *name)
 {
-  return colorize_start (pp_show_color (m_context->printer), name);
+  return colorize_start (pp_show_color (m_context->m_printer), name);
 }
 
 /* Implementation of class layout_range.  */
@@ -781,12 +781,12 @@ layout::layout (diagnostic_context * context,
 		rich_location *richloc,
 		diagnostic_t diagnostic_kind)
 : m_context (context),
-  m_pp (context->printer),
+  m_pp (context->m_printer),
   m_diagnostic_kind (diagnostic_kind),
   m_primary_loc (richloc->get_range (0)->m_loc),
   m_exploc (richloc->get_expanded_location (0)),
   m_colorizer (context, diagnostic_kind),
-  m_colorize_source_p (context->colorize_source_p),
+  m_colorize_source_p (context->m_colorize_source_p),
   m_layout_ranges (richloc->get_num_locations ()),
   m_fixit_hints (richloc->get_num_fixit_hints ()),
   m_line_spans (1 + richloc->get_num_locations ()),
@@ -818,7 +818,7 @@ layout::layout (diagnostic_context * context,
   /* Adjust m_x_offset.
      Center the primary caret to fit in max_width; all columns
      will be adjusted accordingly.  */
-  size_t max_width = m_context->caret_max_width;
+  size_t max_width = m_context->m_caret_max_width;
   char_span line = location_get_source_line (m_exploc.file, m_exploc.line);
   if (line && (size_t)m_exploc.column <= line.length ())
     {
@@ -831,7 +831,7 @@ layout::layout (diagnostic_context * context,
       gcc_assert (m_x_offset >= 0);
     }
 
-  if (context->show_ruler_p)
+  if (context->m_show_ruler_p)
     show_ruler (m_x_offset + max_width);
 }
 
@@ -1233,7 +1233,7 @@ layout::print_annotation_line (int row, const line_bounds lbounds)
 	      /* Draw the caret.  */
 	      char caret_char;
 	      if (state.range_idx < rich_location::STATICALLY_ALLOCATED_RANGES)
-		caret_char = m_context->caret_chars[state.range_idx];
+		caret_char = m_context->get_caret_char (state.range_idx);
 	      else
 		caret_char = '^';
 	      pp_character (m_pp, caret_char);
@@ -1920,11 +1920,11 @@ diagnostic_show_locus (diagnostic_context * context,
 		       rich_location *richloc,
 		       diagnostic_t diagnostic_kind)
 {
-  pp_newline (context->printer);
+  pp_newline (context->m_printer);
 
   location_t loc = richloc->get_loc ();
   /* Do nothing if source-printing has been disabled.  */
-  if (!context->show_caret)
+  if (!context->m_show_caret)
     return;
 
   /* Don't attempt to print source for UNKNOWN_LOCATION and for builtins.  */
@@ -1933,14 +1933,14 @@ diagnostic_show_locus (diagnostic_context * context,
 
   /* Don't print the same source location twice in a row, unless we have
      fix-it hints.  */
-  if (loc == context->last_location
+  if (loc == context->m_last_location
       && richloc->get_num_fixit_hints () == 0)
     return;
 
-  context->last_location = loc;
+  context->m_last_location = loc;
 
-  const char *saved_prefix = pp_get_prefix (context->printer);
-  pp_set_prefix (context->printer, NULL);
+  const char *saved_prefix = pp_get_prefix (context->m_printer);
+  pp_set_prefix (context->m_printer, NULL);
 
   layout layout (context, richloc, diagnostic_kind);
   for (int line_span_idx = 0; line_span_idx < layout.get_num_line_spans ();
@@ -1950,14 +1950,14 @@ diagnostic_show_locus (diagnostic_context * context,
       if (layout.print_heading_for_line_span_index_p (line_span_idx))
 	{
 	  expanded_location exploc = layout.get_expanded_location (line_span);
-	  context->start_span (context, exploc);
+	  context->m_start_span (context, exploc);
 	}
       int last_line = line_span->get_last_line ();
       for (int row = line_span->get_first_line (); row <= last_line; row++)
 	layout.print_line (row);
     }
 
-  pp_set_prefix (context->printer, saved_prefix);
+  pp_set_prefix (context->m_printer, saved_prefix);
 }
 
 #if CHECKING_P
@@ -1974,7 +1974,7 @@ test_diagnostic_show_locus_unknown_location ()
   test_diagnostic_context dc;
   rich_location richloc (line_table, UNKNOWN_LOCATION);
   diagnostic_show_locus (&dc, &richloc, DK_ERROR);
-  ASSERT_STREQ ("\n", pp_formatted_text (dc.printer));
+  ASSERT_STREQ ("\n", pp_formatted_text (dc.m_printer));
 }
 
 /* Verify that diagnostic_show_locus works sanely for various
@@ -1999,7 +1999,7 @@ test_one_liner_simple_caret ()
   ASSERT_STREQ ("\n"
 		" foo = bar.field;\n"
 		"          ^\n",
-		pp_formatted_text (dc.printer));
+		pp_formatted_text (dc.m_printer));
 }
 
 /* Caret and range.  */
@@ -2017,7 +2017,7 @@ test_one_liner_caret_and_range ()
   ASSERT_STREQ ("\n"
 		" foo = bar.field;\n"
 		"       ~~~^~~~~~\n",
-		pp_formatted_text (dc.printer));
+		pp_formatted_text (dc.m_printer));
 }
 
 /* Multiple ranges and carets.  */
@@ -2030,19 +2030,19 @@ test_one_liner_multiple_carets_and_ranges ()
     = make_location (linemap_position_for_column (line_table, 2),
 		     linemap_position_for_column (line_table, 1),
 		     linemap_position_for_column (line_table, 3));
-  dc.caret_chars[0] = 'A';
+  dc.set_caret_char (0, 'A');
 
   location_t bar
     = make_location (linemap_position_for_column (line_table, 8),
 		     linemap_position_for_column (line_table, 7),
 		     linemap_position_for_column (line_table, 9));
-  dc.caret_chars[1] = 'B';
+  dc.set_caret_char (1, 'B');
 
   location_t field
     = make_location (linemap_position_for_column (line_table, 13),
 		     linemap_position_for_column (line_table, 11),
 		     linemap_position_for_column (line_table, 15));
-  dc.caret_chars[2] = 'C';
+  dc.set_caret_char (2, 'C');
 
   rich_location richloc (line_table, foo);
   richloc.add_range (bar, true);
@@ -2051,7 +2051,7 @@ test_one_liner_multiple_carets_and_ranges ()
   ASSERT_STREQ ("\n"
 		" foo = bar.field;\n"
 		" ~A~   ~B~ ~~C~~\n",
-		pp_formatted_text (dc.printer));
+		pp_formatted_text (dc.m_printer));
 }
 
 /* Insertion fix-it hint: adding an "&" to the front of "bar.field". */
@@ -2068,7 +2068,7 @@ test_one_liner_fixit_insert_before ()
 		" foo = bar.field;\n"
 		"       ^\n"
 		"       &\n",
-		pp_formatted_text (dc.printer));
+		pp_formatted_text (dc.m_printer));
 }
 
 /* Insertion fix-it hint: adding a "[0]" after "foo". */
@@ -2087,7 +2087,7 @@ test_one_liner_fixit_insert_after ()
 		" foo = bar.field;\n"
 		" ^~~\n"
 		"    [0]\n",
-		pp_formatted_text (dc.printer));
+		pp_formatted_text (dc.m_printer));
 }
 
 /* Removal fix-it hint: removal of the ".field". */
@@ -2106,7 +2106,7 @@ test_one_liner_fixit_remove ()
 		" foo = bar.field;\n"
 		"          ^~~~~~\n"
 		"          ------\n",
-		pp_formatted_text (dc.printer));
+		pp_formatted_text (dc.m_printer));
 }
 
 /* Replace fix-it hint: replacing "field" with "m_field". */
@@ -2125,7 +2125,7 @@ test_one_liner_fixit_replace ()
 		" foo = bar.field;\n"
 		"           ^~~~~\n"
 		"           m_field\n",
-		pp_formatted_text (dc.printer));
+		pp_formatted_text (dc.m_printer));
 }
 
 /* Replace fix-it hint: replacing "field" with "m_field",
@@ -2151,7 +2151,7 @@ test_one_liner_fixit_replace_non_equal_range ()
 		"     ^\n"
 		"           -----\n"
 		"           m_field\n",
-		pp_formatted_text (dc.printer));
+		pp_formatted_text (dc.m_printer));
 }
 
 /* Replace fix-it hint: replacing "field" with "m_field",
@@ -2176,7 +2176,7 @@ test_one_liner_fixit_replace_equal_secondary_range ()
 		" foo = bar.field;\n"
 		"     ^     ~~~~~\n"
 		"           m_field\n",
-		pp_formatted_text (dc.printer));
+		pp_formatted_text (dc.m_printer));
 }
 
 /* Verify that we can use ad-hoc locations when adding fixits to a
@@ -2210,7 +2210,7 @@ test_one_liner_fixit_validation_adhoc_locations ()
 		  " foo = bar.field;\n"
 		  "       ^~~~~~~~~~                               \n"
 		  "       test\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
   }
 
   /* Remove.  */
@@ -2227,7 +2227,7 @@ test_one_liner_fixit_validation_adhoc_locations ()
 		  " foo = bar.field;\n"
 		  "       ^~~~~~~~~~                               \n"
 		  "       -----------------------------------------\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
   }
 
   /* Replace.  */
@@ -2244,7 +2244,7 @@ test_one_liner_fixit_validation_adhoc_locations ()
 		  " foo = bar.field;\n"
 		  "       ^~~~~~~~~~                               \n"
 		  "       test\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
   }
 }
 
@@ -2264,7 +2264,7 @@ test_one_liner_many_fixits_1 ()
 		" foo = bar.field;\n"
 		"     ^\n"
 		"     aaaaaaaaaaaaaaaaaaa\n",
-		pp_formatted_text (dc.printer));
+		pp_formatted_text (dc.m_printer));
 }
 
 /* Ensure that we can add an arbitrary number of fix-it hints to a
@@ -2287,7 +2287,7 @@ test_one_liner_many_fixits_2 ()
 		" foo = bar.field;\n"
 		"     ^\n"
 		"a a a a a a a a a a a a a a a a a a a\n",
-		pp_formatted_text (dc.printer));
+		pp_formatted_text (dc.m_printer));
 }
 
 /* Run the various one-liner tests.  */
@@ -2375,7 +2375,7 @@ test_add_location_if_nearby (const line_table_case &case_)
     ASSERT_STREQ ("\n"
 		  " struct same_line { double x; double y; ;\n"
 		  "                  ~                    ^\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
   }
 
   /* Test of add_location_if_nearby on a different line to the
@@ -2441,7 +2441,7 @@ test_diagnostic_show_locus_fixit_lines (const line_table_case &case_)
 		  " struct point origin = {x: 0.0,\n"
 		  "                         ^\n"
 		  "                        .=\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
   }
 
   /* The multiline case.  The caret for the rich_location is on line 6;
@@ -2466,7 +2466,7 @@ test_diagnostic_show_locus_fixit_lines (const line_table_case &case_)
 		  "                         : 0.0};\n"
 		  "                         ^\n"
 		  "                         =\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
   }
 }
 
@@ -2675,7 +2675,7 @@ test_overlapped_fixit_printing (const line_table_case &case_)
 		  "                   ^~~~~~~~~~\n"
 		  "            -----------------\n"
 		  "            const_cast<foo *> (ptr->field)\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
 
     /* Unit-test the line_corrections machinery.  */
     ASSERT_EQ (3, richloc.get_num_fixit_hints ());
@@ -2734,7 +2734,7 @@ test_overlapped_fixit_printing (const line_table_case &case_)
 		  "            -\n"
 		  "            CAST (-\n"
 		  "                  ) (        )\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
   }
 
   /* Example where none are consolidated during printing.  */
@@ -2752,7 +2752,7 @@ test_overlapped_fixit_printing (const line_table_case &case_)
 		  "            -\n"
 		  "            CST ( -\n"
 		  "                  ) (        )\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
   }
 
   /* Example of deletion fix-it hints.  */
@@ -2773,7 +2773,7 @@ test_overlapped_fixit_printing (const line_table_case &case_)
 		  "                   ^~~~~~~~~~\n"
 		  "            -------\n"
 		  "            (bar *)\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
   }
 
   /* Example of deletion fix-it hints that would overlap.  */
@@ -2794,7 +2794,7 @@ test_overlapped_fixit_printing (const line_table_case &case_)
 		  "                   ^~~~~~~~~~\n"
 		  "            -----------------\n"
 		  "            (longer *)(foo *)\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
   }
 
   /* Example of insertion fix-it hints that would overlap.  */
@@ -2813,7 +2813,7 @@ test_overlapped_fixit_printing (const line_table_case &case_)
 		  "                   ^~~~~~~~~~\n"
 		  "            -------\n"
 		  "            LONGER THAN THE CAST(foo *)TEST\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
   }
 }
 
@@ -2879,7 +2879,7 @@ test_overlapped_fixit_printing_2 (const line_table_case &case_)
 		  " int a5[][0][0] = { 1, 2 };\n"
 		  "                    ^\n"
 		  "                     } {\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
   }
 
   /* Various overlapping insertions, some occurring "out of order"
@@ -2903,7 +2903,7 @@ test_overlapped_fixit_printing_2 (const line_table_case &case_)
 		  "                    ^\n"
 		  " {                  -----\n"
 		  "                    {{1}}}}, {{{2 }}\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
   }
 }
 
@@ -2943,7 +2943,7 @@ test_fixit_insert_containing_newline (const line_table_case &case_)
 		  "+      break;\n"
 		  "     case 'b':\n"
 		  "     ^~~~~~~~~\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
   }
 
   /* Verify that attempts to add text with a newline fail when the
@@ -2957,7 +2957,7 @@ test_fixit_insert_containing_newline (const line_table_case &case_)
     ASSERT_STREQ ("\n"
 		  "     case 'b':\n"
 		  "     ^~~~~~~~~\n",
-		  pp_formatted_text (dc.printer));
+		  pp_formatted_text (dc.m_printer));
   }
 }
 
@@ -3009,7 +3009,7 @@ test_fixit_insert_containing_newline_2 (const line_table_case &case_)
 		"FILENAME:3:2:\n"
 		"  putchar (ch);\n"
 		"  ^~~~~~~\n",
-		pp_formatted_text (dc.printer));
+		pp_formatted_text (dc.m_printer));
 }
 
 /* Replacement fix-it hint containing a newline.
@@ -3049,7 +3049,7 @@ test_fixit_replace_containing_newline (const line_table_case &case_)
   ASSERT_STREQ ("\n"
 		" foo = bar ();\n"
 		"             ^\n",
-		pp_formatted_text (dc.printer));
+		pp_formatted_text (dc.m_printer));
 }
 
 /* Fix-it hint, attempting to delete a newline.
@@ -3096,7 +3096,7 @@ test_fixit_deletion_affecting_newline (const line_table_case &case_)
 		"          ~^\n"
 		"       );\n"
 		"       ~    \n",
-		pp_formatted_text (dc.printer));
+		pp_formatted_text (dc.m_printer));
 }
 
 /* Run all of the selftests within this file.  */
